<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2006 pragmaMx Dev Team - http://pragmaMx.org
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Dieses Modul basiert auf:
 *     Usermap, Copyright (C) 2004 by 
 *      Andreas Trsch http://www.nukemodule.de
 *      Bernd Mnt http://www.bmservices.de
 * Dieses Modul basiert auf:
 *     PHPKit Usermap 1.2 von www.fletchers-corner.de (28 Oktober 2003)
 * Plz/Geodaten von OpenGeoDB - freie Geokoordinaten-Datenbank, http://opengeodb.de
 */

if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");

$module_name = basename(dirname(__FILE__));

require("modules/" . $module_name . "/Map.php");
$start = gettimeofday();
// changes for pragmaMx
$searchForUserName = false;
// end changes for pragmaMx
if (isset($_GET['usernames'])) {
    $usernames = trim($_GET['usernames']);
    $search_usernames = preg_split('#\s*,\s*#m', $usernames);

    $searchForUserName = true;
} 
// changes for pragmaMx
else {
    $usernames = '';
} 
// end changes for pragmaMx
$Handler['onclick'] = "(navigator.appName=='Netscape')? makeVisible(event) : makeVisible();";
$Handler['onmouseout'] = "self.status='';";
$Handler['onmouseover'] = "self.status='';return true";

$MyMap = new Map("modules/" . $module_name . "/karte.png");
$MyMap->setRange(5.65, 15.2 , 47.2, 55.35);

$Anzahl = 0;
$AlleOrte = array();

$result = sql_query("select uid,uname,user_from,user_sexus from " . $user_prefix . "_users WHERE user_from<>'' AND LENGTH(user_from)>=5");
while (list($uid, $uname, $user_from, $user_sexus) = sql_fetch_row($result)) {
    if (preg_match('#[0-9]{5}#', $user_from, $matches)) {
        $user_from = $matches[0];
        $gender = "n";
        if ($user_sexus == 1) $gender = "m";
        else if ($user_sexus == 2) $gender = "w";
        $genders[$uname] = $gender;
        if (isset($all[$user_from])) {
            $x = $all[$user_from]['x'];
            $y = $all[$user_from]['y'];
        } else {
            $x = 0;
            $y = 0;
            $result1 = sql_query("select laenge,breite from plz_data where plz=$user_from");
            if (sql_num_rows($result1) == 1) {
                list ($x, $y) = sql_fetch_row($result1);
                $x = ($x-5.65) * 750 / (15.2-5.65);
                $y = (55.35 - $y) * 1024 / (55.35-47.2);
                $x = (round($x / 8) * 8);
                $y = (round($y / 8) * 8);
            } 
            $all[$user_from]['x'] = $x;
            $all[$user_from]['y'] = $y;
        } 
        if ($x && $y) {
            if (isset($AlleOrte[$x . ":" . $y])) {
                $AlleOrte["$x:$y"]["userids"][] = $uid;
                $AlleOrte["$x:$y"]["usernames"][] = $uname;
            } else {
                $AlleOrte["$x:$y"] = array("userids" => array($uid),
                    "usernames" => array($uname),
                    "x" => $x,
                    "y" => $y
                    );
            } 
            $Anzahl++;
        } 
    } 
} 

foreach($AlleOrte as $ort) {
    unset($pinLink);
    $isSearched = false;
    foreach($ort["userids"] as $key => $id) {
        if ($searchForUserName && in_array($ort["usernames"][$key], $search_usernames)) $isSearched = true;
        $pinLink[] = $ort["usernames"][$key];
    } 
    if ($isSearched) {
        $MyMap->addImg($ort["x"], $ort["y"], "modules/" . $module_name . "/kreuz.png", 21);
    } 
    $theNames = join(",", $ort["usernames"]);
    $g = "";
    foreach ($pinLink as $u) {
        $g .= $genders[$u];
    } 
    $m = strpos($g, "m");
    $w = strpos($g, "w");
    $color = "rotblau";
    if ($w === false) $color = "blau";
    if ($m === false) $color = "rot";
    $MyMap->addPin($ort["x"], $ort["y"], "modules/" . $module_name . "/$color.png", 8, 1, $theNames, "modules.php?name=" . $module_name . "&amp;file=viewusers&amp;names=" . join(",", $pinLink), $Handler['onclick'], $Handler['onmouseover'], $Handler['onmouseout']);
    if ($ort["x"] == 0) {
        print_r($ort);
    } 
} 
// changes for pragmaMx
// session_start();
// end changes for pragmaMx
$_SESSION["usermap"] = $MyMap->dumpbuffer();
$end = gettimeofday();
$start = $start["sec"] + ($start["usec"] / 1000000.0);
$end = $end["sec"] + ($end["usec"] / 1000000.0);
$sec = $end - $start;

include("header.php");
if (!defined('_ol_bgcolor')) define("_ol_bgcolor", $bgcolor2); # Border color and color of caption. Usually a dark color (black, brown etc)
if (!defined('_ol_capcolor')) define("_ol_capcolor", $textcolor2); # Color of the caption text. Usually a bright color
if (!defined('_ol_closecolor')) define("_ol_closecolor", $textcolor2); # Color of "Close" when using Sticky. Usually a semi-bright color

title('Mitgliederkarte');
opentable();

?>
<script language="Javascript" type="text/javascript">
    <!--
    function hide(){
    document.getElementById('fenster').style.visibility='hidden';
    }

    function makeVisible(e){
    if(navigator.appName=="Netscape"){
    X=e.pageX;
    Y=e.pageY;
    }else{
    X=window.event.clientX+document.body.scrollLeft;
    Y=window.event.clientY+document.body.scrollTop;
    }
    X+=20;
    Y-=20;
    document.getElementById("fenster").style.top=Y;
    document.getElementById("fenster").style.left=X;
    document.getElementById("fenster").style.visibility="visible";
    }
    -->
</script>
<style type="text/css">
    a.close {color:#FFFFFF; font-weight:bold;  text-decoration:none;}
    a.close:visited {color:#FFFFFF; font-weight:bold; text-decoration:none;}
    img{border:none;}
    #fenster{position:absolute; top:0px; left:0px; border: none; visibility:hidden;}
    #profiles{height:100px; width:100px; border:none; padding:0px; margin:0px;}
</style>

<p align=center>Es werden <b><?php echo $Anzahl ?> </b>Mitglieder angezeigt.</p>
<hr width="75%" noshade>
<form name="Suche" action="modules.php" method="get" style="text-align:center">
<input type="hidden" name="name" value="Usermap">
Suche nach: <input type="text" name="usernames" value="<?php echo mxPrepareToDisplay($usernames)?>" size="60">&nbsp;<input type="submit" value="Suchen"><br>
(Es knnen mehrere Benutzernamen durch Komma getrennt angegeben werden)
</form>
<img src="modules.php?name=<?php echo $module_name ?>&amp;file=karte" usemap="#myusermap">
<?php print($MyMap->getImageMap("myusermap"));

?>
<p align=right>Es werden <?php echo $Anzahl?> Mitglieder angezeigt.<br>
Karte erstellt in <?php printf("%0.3f", $sec)?> Sekunden.</p>

<div id="fenster">
<table style="border: solid <?php echo _ol_bgcolor ?> 1px; margin: 0px; border-collapse: collapse;"><tr>
<td style="text-align: right; border: none; background-color: <?php echo _ol_bgcolor ?>; color: <?php echo _ol_closecolor ?>;">
<a class="close" onmouseover="self.status='';return true" onmouseout="self.status='';" href="javascript:self.status='';hide()">X</a></td></tr><tr>
<td style="padding:0px; margin:0px;">
<iframe frameborder=0 id="profiles" src="modules.php?name=<?php echo $module_name ?>&amp;file=viewusers" name="profiles"></iframe>
</td></tr></table></div>

<?php
closetable();
include("footer.php");

?>
